"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DynamoDBDocumentService = exports.makeDynamoDBDocumentService = void 0;
const lib_dynamodb_1 = require("@aws-sdk/lib-dynamodb");
const client_dynamodb_1 = require("@effect-aws/client-dynamodb");
const commons_1 = require("@effect-aws/commons");
const effect_1 = require("effect");
const Instance = __importStar(require("./DynamoDBDocumentClientInstance.js"));
const DynamoDBDocumentServiceConfig = __importStar(require("./DynamoDBDocumentServiceConfig.js"));
const commands = {
    BatchExecuteStatementCommand: lib_dynamodb_1.BatchExecuteStatementCommand,
    BatchGetCommand: lib_dynamodb_1.BatchGetCommand,
    BatchWriteCommand: lib_dynamodb_1.BatchWriteCommand,
    DeleteCommand: lib_dynamodb_1.DeleteCommand,
    ExecuteStatementCommand: lib_dynamodb_1.ExecuteStatementCommand,
    ExecuteTransactionCommand: lib_dynamodb_1.ExecuteTransactionCommand,
    GetCommand: lib_dynamodb_1.GetCommand,
    PutCommand: lib_dynamodb_1.PutCommand,
    QueryCommand: lib_dynamodb_1.QueryCommand,
    ScanCommand: lib_dynamodb_1.ScanCommand,
    TransactGetCommand: lib_dynamodb_1.TransactGetCommand,
    TransactWriteCommand: lib_dynamodb_1.TransactWriteCommand,
    UpdateCommand: lib_dynamodb_1.UpdateCommand,
};
/**
 * @since 1.0.0
 * @category constructors
 */
exports.makeDynamoDBDocumentService = effect_1.Effect.gen(function* () {
    const client = yield* Instance.DynamoDBDocumentClientInstance;
    return commons_1.Service.fromClientAndCommands(client, commands, {
        resolveClientConfig: client_dynamodb_1.DynamoDBServiceConfig.toDynamoDBClientConfig,
    });
});
/**
 * @since 1.0.0
 * @category models
 */
class DynamoDBDocumentService extends effect_1.Effect.Tag("@effect-aws/lib-dynamodb/DynamoDBDocumentService")() {
    static defaultLayer = effect_1.Layer.effect(this, exports.makeDynamoDBDocumentService).pipe(effect_1.Layer.provide(Instance.layer));
    static layer = (config) => effect_1.Layer.effect(this, exports.makeDynamoDBDocumentService).pipe(effect_1.Layer.provide(Instance.layer), effect_1.Layer.provide(DynamoDBDocumentServiceConfig.setDynamoDBDocumentServiceConfig(config)));
    static baseLayer = (evaluate) => effect_1.Layer.effect(this, exports.makeDynamoDBDocumentService).pipe(effect_1.Layer.provide(effect_1.Layer.effect(Instance.DynamoDBDocumentClientInstance, effect_1.Effect.map(client_dynamodb_1.DynamoDBServiceConfig.toDynamoDBClientConfig, evaluate))));
}
exports.DynamoDBDocumentService = DynamoDBDocumentService;
//# sourceMappingURL=DynamoDBDocumentService.js.map