"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toTranslateConfig = exports.setDynamoDBDocumentServiceConfig = exports.withDynamoDBDocumentServiceConfig = void 0;
const effect_1 = require("effect");
const Function_1 = require("effect/Function");
const GlobalValue_1 = require("effect/GlobalValue");
/**
 * @since 1.0.0
 * @category dynamodb service config
 */
const currentDynamoDBDocumentServiceConfig = (0, GlobalValue_1.globalValue)("@effect-aws/lib-dynamodb/currentDynamoDBDocumentServiceConfig", () => effect_1.FiberRef.unsafeMake({}));
/**
 * @since 1.0.0
 * @category dynamodb service config
 */
exports.withDynamoDBDocumentServiceConfig = (0, Function_1.dual)(2, (effect, config) => effect_1.Effect.locally(effect, currentDynamoDBDocumentServiceConfig, config));
/**
 * @since 1.0.0
 * @category dynamodb service config
 */
const setDynamoDBDocumentServiceConfig = (config) => effect_1.Layer.locallyScoped(currentDynamoDBDocumentServiceConfig, config);
exports.setDynamoDBDocumentServiceConfig = setDynamoDBDocumentServiceConfig;
/**
 * @since 1.0.0
 * @category adapters
 */
exports.toTranslateConfig = effect_1.FiberRef.get(currentDynamoDBDocumentServiceConfig);
//# sourceMappingURL=DynamoDBDocumentServiceConfig.js.map