import { Effect, FiberRef, Layer } from "effect";
import { dual } from "effect/Function";
import { globalValue } from "effect/GlobalValue";
/**
 * @since 1.0.0
 * @category dynamodb service config
 */
const currentDynamoDBDocumentServiceConfig = globalValue("@effect-aws/lib-dynamodb/currentDynamoDBDocumentServiceConfig", () => FiberRef.unsafeMake({}));
/**
 * @since 1.0.0
 * @category dynamodb service config
 */
export const withDynamoDBDocumentServiceConfig = dual(2, (effect, config) => Effect.locally(effect, currentDynamoDBDocumentServiceConfig, config));
/**
 * @since 1.0.0
 * @category dynamodb service config
 */
export const setDynamoDBDocumentServiceConfig = (config) => Layer.locallyScoped(currentDynamoDBDocumentServiceConfig, config);
/**
 * @since 1.0.0
 * @category adapters
 */
export const toTranslateConfig = FiberRef.get(currentDynamoDBDocumentServiceConfig);
//# sourceMappingURL=DynamoDBDocumentServiceConfig.js.map